Index: nb_celp.c
===================================================================
--- nb_celp.c	(revision 11463)
+++ nb_celp.c	(working copy)
@@ -189,8 +189,10 @@
    
    st->pitch = speex_alloc((st->nbSubframes)*sizeof(int));
 
+#ifdef KEEP_ALL
    st->vbr = speex_alloc(sizeof(VBRState));
    vbr_init(st->vbr);
+#endif /* KEEP_ALL */
    st->vbr_quality = 8;
    st->vbr_enabled = 0;
    st->vad_enabled = 0;
@@ -233,8 +235,10 @@
    speex_free (st->pi_gain);
    speex_free (st->pitch);
 
+#ifdef KEEP_ALL
    vbr_destroy(st->vbr);
    speex_free (st->vbr);
+#endif /* KEEP_ALL */
 
 #ifdef VORBIS_PSYCHO
    vorbis_psy_destroy(st->psy);
@@ -345,7 +349,11 @@
 
 
       /*Open-loop pitch*/
+#ifdef KEEP_ALL
       if (st->complexity>2 || !st->submodes[st->submodeID] || st->vbr_enabled || st->vad_enabled || SUBMODE(forced_pitch_gain) ||
+#else
+      if (st->complexity>2 || !st->submodes[st->submodeID] || st->vad_enabled || SUBMODE(forced_pitch_gain) ||
+#endif /* KEEP_ALL */
           SUBMODE(lbr_pitch) != -1)
       {
          int nol_pitch[6];
@@ -450,6 +458,7 @@
          st->old_curve[i] = st->curve[i];
 #endif
 
+#ifdef KEEP_ALL
    /*VBR stuff*/
    if (st->vbr && (st->vbr_enabled||st->vad_enabled))
    {
@@ -550,8 +559,11 @@
          st->submodeID=mode;
       } 
    } else {
+#endif /* KEEP_ALL */
       st->relative_quality = -1;
+#ifdef KEEP_ALL
    }
+#endif /* KEEP_ALL */
 
    if (st->encode_submode)
    {
@@ -1278,6 +1290,7 @@
          wideband = speex_bits_unpack_unsigned(bits, 1);
          if (wideband) /* Skip wideband block (for compatibility) */
          {
+#ifdef KEEP_ALL
             int submode;
             int advance;
             advance = submode = speex_bits_unpack_unsigned(bits, SB_SUBMODE_BITS);
@@ -1312,6 +1325,10 @@
                }
 
             }
+#else
+            speex_warning ("Invalid wideband mode encountered: corrupted stream?");
+            return -2;
+#endif /* KEEP_ALL */
          }
          if (speex_bits_remaining(bits)<4)
             return -1;
@@ -1812,12 +1829,14 @@
    case SPEEX_GET_MODE:
       (*(int*)ptr) = st->submodeID;
       break;
+#ifdef KEEP_ALL
    case SPEEX_SET_VBR:
       st->vbr_enabled = (*(int*)ptr);
       break;
    case SPEEX_GET_VBR:
       (*(int*)ptr) = st->vbr_enabled;
       break;
+#endif /* KEEP_ALL */
    case SPEEX_SET_VAD:
       st->vad_enabled = (*(int*)ptr);
       break;
@@ -1830,6 +1849,7 @@
    case SPEEX_GET_DTX:
       (*(int*)ptr) = st->dtx_enabled;
       break;
+#ifdef KEEP_ALL
    case SPEEX_SET_ABR:
       st->abr_enabled = (*(int*)ptr);
       st->vbr_enabled = 1;
@@ -1864,6 +1884,7 @@
    case SPEEX_GET_VBR_QUALITY:
       (*(float*)ptr) = st->vbr_quality;
       break;
+#endif /* KEEP_ALL */
    case SPEEX_SET_QUALITY:
       {
          int quality = (*(int*)ptr);
